fn packRleStream strm =
(
	local rleArray = #(), maxFrames = 126, currPos,runLength
	rleArray[1] = strm.count
	rleArray[2] = 0
	local Writing_NonRle = false, startNonRlePos = 1
	local tmpEndPos, specialCase = false
	
	currPos = 1
	while currPos <= rleArray[1] do
	(
	
		if not Writing_NonRle do
		(		
			if (currPos + maxFrames - 1) < rleArray[1] then
				tmpEndPos = currPos + maxFrames - 1
			else
				tmpEndPos = rleArray[1]
		)
		

		for i = (currPos + 1) to tmpEndPos do
		(
			if strm[currPos] == strm[i] then
			(
				if i == tmpEndPos do
				(
					if tmpEndPos == rleArray[1] do
						specialCase = true
					runLength = i - currPos + 1
				)
			)
			else 
			(
				runLength = i - currPos
				exit
			)
		)
		
		if runLength > 2 then -- rle Pack
		(
			if Writing_NonRle do
			(
				Writing_NonRle = false
				rleArray[startNonRlePos] = rleArray.count - startNonRlePos 
			)
			
			rleArray[rleArray.count + 1] = true -- isRLE
			rleArray[2] += 2
			rleArray[rleArray.count + 1] = runLength -- t_numFrames
			rleArray[rleArray.count + 1] = strm[currPos]
			currPos += runLength
			lastHeaderPos = currPos
			runLength = 1
		)
		else -- uncompressed
		(
			if not Writing_NonRle do
			(
				Writing_NonRle = true
				rleArray[rleArray.count + 1] = false -- isNotRLE
				rleArray[2] += 1
				rleArray[rleArray.count + 1] = 1 -- t_numFrames (put dummy placeholder, change later)
				startNonRlePos = rleArray.count
			)
			if currPos == tmpEndPos do
			(
				rleArray[startNonRlePos] = rleArray.count - startNonRlePos + 1
				Writing_NonRle = false
			)
			for j=0 to (runLength-1) do
			(
				rleArray[rleArray.count + 1] = strm[currPos + j]
				rleArray[2] += 1
			)
				
			currPos += runLength
			
			if specialCase do
				rleArray[startNonRlePos] = rleArray.count - startNonRlePos
		)
	)
	local tmpCntA = rleArray.count
	for i=1 to tmpCntA do
	(
		if rleArray[i] == undefined do
		( 	deleteItem rleArray i
			rleArray[2] -= 1
		)
	)
	return rleArray
)

(
	clearListener()
	a = #(1,1,1,1,1,1,2)
	b = packRleStream a
)
